<!--- 
The contents of this file are subject to the Mozilla Public License Version 1.1
(the "License"); you may not use this file except in compliance with the
License. You may obtain a copy of the License at http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
the specific language governing rights and limitations under the License.

The Original Code is comprised of the PT Poll directory

The Initial Developer of the Original Code is
PaperThin, Inc. Copyright(C) 2012.
All Rights Reserved.

By downloading, modifying, distributing, using and/or accessing any files 
in this directory, you agree to the terms and conditions of the applicable 
end user license agreement.
--->

<cfscript>
	// the fields current value
	currentValue = attributes.currentValues[fqFieldName];
	// the param structure which will hold all of the fields from the props dialog
	xparams = parameters[fieldQuery.inputID];
	// find if we need to render the simple form field
	renderSimpleFormField = false;
	if ( (StructKeyExists(request, "simpleformexists")) AND (request.simpleformexists EQ 1) )
		renderSimpleFormField = true;
	application.ptPoll.scripts.loadJQuery();
	application.ptPoll.scripts.loadJQuerySelectboxes();
	application.ptPoll.scripts.loadCFJS();
</cfscript>
<cfoutput>
	<script>
		// javascript validation to make sure they have text to be converted
		#fqFieldName#=new Object();
		#fqFieldName#.id='#fqFieldName#';
		#fqFieldName#.tid=#rendertabindex#;
		#fqFieldName#.validator="handleSave()";
		// push on to validation array
		vobjects_#attributes.formname#.push(#fqFieldName#);
		jQuery(function(){
			// bind onchange to build the options
			jQuery("##voteOptions").change(handleAddOptionField);
			loadOptions();
		});
		// handle the changing of the number of options to add
		function handleAddOptionField(){
			// get the current value of the field
			var inputs = jQuery("##voteOptions").selectedValues()[0];
			// check to see how many are there already
			var curLen = jQuery("##voteOptionFields").children().length;
			var count = 0;
			// if we have extra, remove them
			if (curLen > 0 && curLen > inputs) {
				jQuery("##voteOptionFields").children().each(function(){
					count++;
					if( count > inputs )
					 jQuery(this).remove();
					 // shrink the height of the div
					 adjustHeight();
				});
			}
			else {// iterate and build new textfields
				for (curLen; curLen < inputs; curLen++) {
					addTextField("");
					adjustHeight();
				}
			}
		}
		// add a new text field into the div
		function addTextField(textVal){
			var txtField = "<li><input type='text' size='40' class='optionVal' value='" + textVal + "' /></li>";
			jQuery("##voteOptionFields").append(txtField);
		}
		// loads the current values into the text fields
		function loadOptions(){
			// get the current values as an array
			var vals = jQuery.ListToArray("#currentValue#");
			// set the selected value and then trigger the select event
			jQuery("##voteOptions").selectOptions(vals.length.toString());
			handleAddOptionField();
			// fill in the values
			jQuery("##voteOptionFields").children().each(function(i){
				jQuery(this).children("input").val(vals[i]);
			});
		}
		// called when the custom element form is submitted
		function handleSave(){
			var rtnStr = "";
			// loop through the children fields and repackage their data for storage
			jQuery("##voteOptionFields").children().children("input").each(function(i){
				if(i == 0)
					rtnStr = jQuery(this).val();
				else
					rtnStr = rtnStr + "," + jQuery.trim(jQuery(this).val());
				// store the new value into the hidden field
				jQuery("###fqFieldName#").val(rtnStr);
			});
			return true;
		}
		// handles adjusting the height
		function adjustHeight(){
			jQuery("##fieldContainer").height( ((jQuery("##voteOptionFields").children().length * 75)/2) );
		}
	</script>
	<style type="text/css">
		##fieldContainer{
			width: 200px;
			margin-left: 2px;
		}
		##voteOptionFields{
			list-style: none !important;
			margin-left: 3px;
			padding: 0px;
		}
		##voteOptionFields li{
			padding-top: 2px;
			padding-bottom: 2px;
			background: url() !important;
		}
	</style>
	<!--- // determine if this is rendererd in a simple form or the standard custom element interface --->
	<cfscript>
		if ( structKeyExists(request, "element") )
		{
			labelText = '<span class="CS_Form_Label_Baseline"><label for="#fqFieldName#">#xParams.label#:</label></span>';
			tdClass = 'CS_Form_Label_Baseline';
		}
		else
		{
			labelText = '<label for="#fqFieldName#">#xParams.label#:</label>';
			tdClass = 'cs_dlgLabel';
		}
	</cfscript>
	<tr>
		<td colspan="2" class="cs_dlgLabelSmall">
			<p>Select the number of question options</p>
			<label for="voteOptions">Vote Options:</label> <select name="voteOptions" id="voteOptions" size="1">
				<option value="0">0</option>
				<option value="1">1</option>
				<option value="2">2</option>
				<option value="3">3</option>
				<option value="4">4</option>
				<option value="5">5</option>
				<option value="6">6</option>
				<option value="7">7</option>
				<option value="8">8</option>
				<option value="9">9</option>
				<option value="10">10</option>
				<option value="11">11</option>
				<option value="12">12</option>
			</select>
			<p>&nbsp;</p>
			<div id="fieldContainer">
				<ul id="voteOptionFields">
				</ul>
			</div>
			<!--- hidden field to store the value --->
			<input type="hidden" name="#fqFieldName#" id="#fqFieldName#" value="#currentValue#">
		</td>
	</tr>
	
	<!--- // include hidden field for simple form processing --->
	<cfif renderSimpleFormField>
		<input type="hidden" name="#fqFieldName#_FIELDNAME" id="#fqFieldName#_FIELDNAME" value="#ReplaceNoCase(fqFieldName, 'fic_','')#">
	</cfif>
</cfoutput>